Bug 509789 - got "received packet with own address as source address" in dom0
got "received packet with own address as source address" in dom0
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: xen (Show other bugs)
5.3
All Linux
low Severity medium
: rc
: ---
Assigned To: Paolo Bonzini
Virtualization Bugs
:
: 319121 (view as bug list)
Depends On:
Blocks: 514499
  Show dependency treegraph
 
Reported: 2009-07-06 04:28 EDT by wmg
Modified: 2011-05-18 12:26 EDT (History)
11 users (show)

See Also:
Fixed In Version: xen-3.0.3-119.el5
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-13 17:17:38 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch (1.78 KB, patch)
2010-09-17 08:58 EDT, Paolo Bonzini
no flags Details | Diff
complete version of the patch (4.00 KB, patch)
2010-09-17 09:46 EDT, Paolo Bonzini
no flags Details | Diff

  None (edit)
Description wmg 2009-07-06 04:28:32 EDT
Description of problem:

I keep seeing the following error message, 
in dom0's dmesg with kernel-xen-2.6.128-1.* with Xen version 3.1.2-128.1.8.el5
hypervisor, but didn't see it on the same machine with 2.6.128-92* kernel

printk: 17 messages suppressed.
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
printk: 8 messages suppressed.
peth1: received packet with  own address as source address
printk: 17 messages suppressed.
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address




Version-Release number of selected component (if applicable):


How reproducible:

just install a rhel5 system with kernel-xen-2.6.128-1.* installed

Steps to Reproduce:
1.
2.
3.
  
Actual results:

got "received packet with  own address as source address" in dom0's dmesg

Expected results:

Additional info:
Comment 1 wmg 2009-07-06 04:35:24 EDT
also seeing this with 5.4 kernel:


[root@dhcp-66-70-83 ~]# dmesg | tail
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
printk: 8 messages suppressed.
peth1: received packet with  own address as source address
[root@dhcp-66-70-83 ~]# uname -r
2.6.18-156.el5xen
[root@dhcp-66-70-83 ~]# arch
x86_64
[root@dhcp-66-70-83 ~]#
Comment 2 wmg 2009-07-06 22:12:28 EDT
with  xen 3.1.2-156.el5 and kernel 2.6.18-92.el5xen also seeing this:

[root@dhcp-66-70-83 ~]# xm dmesg | grep version
 Xen version 3.1.2-156.el5 (mockbuild@redhat.com) (gcc version 4.1.2 20080704 (Red Hat 4.1.2-44)) Mon Jun 29 18:15:35 EDT 2009
(XEN) Processor #0 6:15 APIC version 20
(XEN) Processor #1 6:15 APIC version 20
(XEN) IOAPIC[0]: apic_id 8, version 32, address 0xfec00000, GSI 0-23
[root@dhcp-66-70-83 ~]# uname -r
2.6.18-92.el5xen
[root@dhcp-66-70-83 ~]# dmesg | tail
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
peth1: received packet with  own address as source address
printk: 8 messages suppressed.
peth1: received packet with  own address as source address
Comment 3 Chris Lalancette 2009-07-29 09:56:03 EDT
Probably a kernel-xen problem, so changing components.

Chris Lalancette
Comment 4 Paolo Bonzini 2009-11-20 05:34:14 EST
http://bugzilla.xensource.com/bugzilla/show_bug.cgi?id=339 suggests this:

> the solution is to assign a unique MAC to the vif/peth devices, for every dom0
> on your network. I also anticipated that a single dom0 with two physical NICs
> plugged into the same switch would encounter this error, and thus based the MAC
> off a combination of a unique identifier, and the eth number.

This patch is nowhere near being in shape for RHEL, but explains the idea:

http://bugzilla.xensource.com/bugzilla/attachment.cgi?id=535
Comment 7 Michal Novotny 2010-05-07 06:50:17 EDT
(In reply to comment #4)
> http://bugzilla.xensource.com/bugzilla/show_bug.cgi?id=339 suggests this:
> 
> > the solution is to assign a unique MAC to the vif/peth devices, for every dom0
> > on your network. I also anticipated that a single dom0 with two physical NICs
> > plugged into the same switch would encounter this error, and thus based the MAC
> > off a combination of a unique identifier, and the eth number.
> 
> This patch is nowhere near being in shape for RHEL, but explains the idea:
> 
> http://bugzilla.xensource.com/bugzilla/attachment.cgi?id=535    

Did you took Paolo's advice and is it working fine for you by now? If it's done by setting up a MAC address in network-bridge script it would be a part of xen component so please could you try with -107.el5virttest25 RPMs available from:

http://people.redhat.com/mrezanin/xen/

Thanks,
Michal
Comment 8 wmg 2010-06-04 10:23:34 EDT
looks like this is the solution,

but I don't have a test environment for now,
I think it's safe to push that patch
Comment 9 Michal Novotny 2010-06-07 04:55:08 EDT
(In reply to comment #8)
> looks like this is the solution,
> 
> but I don't have a test environment for now,
> I think it's safe to push that patch    

I'd love to but testing this first is necessary. Unfortunately I'm not seeing those messages any longer using the latest version of Xen package.

Michal
Comment 10 Paolo Bonzini 2010-06-07 06:13:43 EDT
Michal,

to see the messages you need a particular network configuration as explained in the xensource bugreport.  Anyway, the patch is just a proof of concept: users cannot be expected to change the contents of /etc/xen/network-bridge, hence my comment that "the patch is nowhere near being in shape for RHEL".
Comment 11 Michal Novotny 2010-06-22 10:57:10 EDT
Paolo,

thanks for your reply  but I'm not seeing the link for xensource bugreport and also I cannot find it since I've tried now with no luck.

Could you give me the link please?

Thanks,
Michal
Comment 12 Paolo Bonzini 2010-06-22 12:35:02 EDT
Michal, see comment #4.
Comment 13 Michal Novotny 2010-06-23 05:49:18 EDT
(In reply to comment #12)
> Michal, see comment #4.    

Oh, I overlooked this bugzilla was on xensource :( Sorry.

Michal
Comment 14 Michal Novotny 2010-06-28 10:08:01 EDT
Hi,
what's your network configuration to be able to reproduce it? In fact I did read the bugzilla on xensource but I was unable to find their configuration with the steps to reproduce it.

Thanks,
Michal
Comment 15 Paolo Bonzini 2010-06-28 13:11:17 EDT
You can try connecting two machines with a cross cable.
Comment 16 Michal Novotny 2010-06-29 07:31:13 EDT
(In reply to comment #15)
> You can try connecting two machines with a cross cable.    

You mean 2 physical (host) machines using the cross table ? Any other and better setup that doesn't require 2 machines is available and one machine is good for that ?

Michal
Comment 20 Paolo Bonzini 2010-09-17 07:49:50 EDT
One idea could be to use the address of eth0, but with bit 1 of the first octet set to 1.  For example, if eth0's address is 00:22:64:B5:2D:B5, you can use 02:22:64:B5:2D:B5 for peth0.
Comment 21 Paolo Bonzini 2010-09-17 08:58:51 EDT
Created attachment 448004 [details]
patch

This is a patch that should work for this.

However, I don't think this can be deployed by default.

I think we should make a new network script network-bridge-multi and write a kbase article suggesting it in case this error shows up.  This is because the dummy fe:ff:ff:ff:ff:ff address is present in a lot of Xen books and tutorials, and even in the RHEL Virtualization Guide.

This way, people who aren't bothered by the message will see no change.
Comment 22 Paolo Bonzini 2010-09-17 09:46:48 EDT
Created attachment 448014 [details]
complete version of the patch
Comment 28 Qixiang Wan 2010-11-23 05:14:52 EST
QE reproduced this with xen-3.0.3-117.el5, verified the fix with xen-3.0.3-119.el5.

We haven't seen the error messages in RHEL for a long time, anyone want to reproduce this can have a try with the following steps:
1. connect two xen hosts (Host A and Host B) with cross cable and configure the network of them (static ip is just ok)
2. from Host A:

$ /etc/init.d/xend stop
$ export netdev=eth0
$ /etc/init.d/xend start
$ ifconfig xenbr0 arp

3. then you will see the error messages "received packet with own address as source address" on host B with 'dmesg' just after enable arp on xenbr0. (Need to reboot Host A and issue the commands if you want to see it again)

Verified with xen-3.0.3-119.el5:
1. use 'network-bridge-mac' as the network-script in xend-config.sxp
2. reboot hosts
3. ifconfig, check the macaddr for peth0, xenbr0 and vif0.0, them are changed  to mac which generated from eth0's mac (bit 1 of the first octet set to 1)
4. try the reproduce approach above, didn't see any error message.

$ ifconfig

eth0      Link encap:Ethernet  HWaddr 00:23:7D:53:AB:D1  
          inet addr:192.168.1.1  Bcast:192.168.1.255  Mask:255.255.255.0
          inet6 addr: fe80::223:7dff:fe53:abd1/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:29 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0 
          RX bytes:0 (0.0 b)  TX bytes:7704 (7.5 KiB)

lo        Link encap:Local Loopback  
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:27 errors:0 dropped:0 overruns:0 frame:0
          TX packets:27 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0 
          RX bytes:67389 (65.8 KiB)  TX bytes:67389 (65.8 KiB)

peth0     Link encap:Ethernet  HWaddr 02:23:7D:53:AB:D1  
          inet6 addr: fe80::23:7dff:fe53:abd1/64 Scope:Link
          UP BROADCAST RUNNING NOARP  MTU:1500  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:29 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000 
          RX bytes:0 (0.0 b)  TX bytes:7868 (7.6 KiB)
          Interrupt:17 Memory:d8800000-d8810000 

vif0.0    Link encap:Ethernet  HWaddr 02:23:7D:53:AB:D1  
          inet6 addr: fe80::23:7dff:fe53:abd1/64 Scope:Link
          UP BROADCAST RUNNING NOARP  MTU:1500  Metric:1
          RX packets:29 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0 
          RX bytes:7704 (7.5 KiB)  TX bytes:0 (0.0 b)

virbr0    Link encap:Ethernet  HWaddr 00:00:00:00:00:00  
          inet addr:192.168.122.1  Bcast:192.168.122.255  Mask:255.255.255.0
          inet6 addr: fe80::200:ff:fe00:0/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:28 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0 
          RX bytes:0 (0.0 b)  TX bytes:6864 (6.7 KiB)

xenbr0    Link encap:Ethernet  HWaddr 02:23:7D:53:AB:D1  
          UP BROADCAST RUNNING NOARP  MTU:1500  Metric:1
          RX packets:29 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0 
          RX bytes:7298 (7.1 KiB)  TX bytes:0 (0.0 b)
Comment 30 errata-xmlrpc 2011-01-13 17:17:38 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0031.html
Comment 31 Paolo Bonzini 2011-05-18 12:26:34 EDT
*** Bug 319121 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.